import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JFrame;

public class DrawingExample {

    public static void main(String[] args) throws IOException {

        // Initialisiere ein Fenster mit dem Titel "Game".
        JFrame window = new JFrame("Game");
        BufferedImage[] images = new BufferedImage[3];
        Handler handler;
        File imagesDir = new File("res" + File.separator + "images");

        // Setze die Größe des Fensters auf 640x480 Pixel. Beachten Sie, dass
        // diese Größe inklusive aller Fensterdekorationen ist - dies gilt auch
        // für den Zeichenbereich, welcher teilweise z.B. durch die
        // Fensterleiste verdeckt wird.
        window.setSize(640, 480);
        // Beim Schließen des Fensters soll das Programm beendet werden.
        window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        // Der Nutzer soll die Größe des Fensters nicht verändern können.
        window.setResizable(false);
        // Öffnet das Fenster. Erst nach Aufruf dieser Methode liefert die
        // Methode getGraphics() einen Wert != null zurück.
        window.setVisible(true);

        handler = new Handler(window.getGraphics(), images);

        // Registriere das handler-Objekt als KeyListener. Beim Tastendruck wird
        // dann automatisch seine keyPressed-Methode aufgerufen.
        window.addKeyListener(handler);

        // Initialisiere das obige Array mit drei Bildern, die wir hier aus
        // Dateien lesen.
        images[0] = ImageIO.read(new File(imagesDir, "mapcell.png"));
        images[1] = ImageIO.read(new File(imagesDir, "wall.png"));
        images[2] = ImageIO.read(new File(imagesDir, "wall_special.png"));
    }

}
