package game.objects;

import geometry.Circle;
import geometry.Point2D;
import geometry.Vector2D;

import java.lang.reflect.*;

import static org.junit.Assert.*;
import org.junit.Test;

public class CreatureTest {
	@Test
	public void testMove() {
		try {
			Class<?> testCreature = Creature.class;
			Class<?>[] types = new Class[] { double.class };
			Field circ = testCreature.getDeclaredField("boundingCircle");
			Field speed = testCreature.getDeclaredField("speed");
			Field direction = testCreature.getDeclaredField("direction");
			Method move = testCreature.getDeclaredMethod("move", types);
			circ.setAccessible(true);
			speed.setAccessible(true);
			direction.setAccessible(true);
			move.setAccessible(true);

			Constructor<?>[] cons = testCreature.getDeclaredConstructors();

			cons[0].setAccessible(true);
			Class<?>[] params = cons[0].getParameterTypes();
			Object creature = cons[0].newInstance(new Object[params.length]);

			circ.set(creature, new Circle(new Point2D(1, 1), 1));
			speed.set(creature, 1.0);
			direction.set(creature, new Vector2D(0, 1));

			move.invoke(creature, new Object[] { new Double(3) });
			assertEquals(((Circle) circ.get(creature)).getCenter().getX(), 1,
					0.01);
			assertEquals(((Circle) circ.get(creature)).getCenter().getY(), 4,
					0.01);

			direction.set(creature, new Vector2D(-1, 0));
			speed.set(creature, 0);
			move.invoke(creature, new Object[] { new Double(.5) });
			assertEquals(((Circle) circ.get(creature)).getCenter().getX(), 1,
					0.01);
			assertEquals(((Circle) circ.get(creature)).getCenter().getY(), 4,
					0.01);

			speed.set(creature, 4);
			move.invoke(creature, new Object[] { new Double(.5) });
			assertEquals(((Circle) circ.get(creature)).getCenter().getX(), -1,
					0.01);
			assertEquals(((Circle) circ.get(creature)).getCenter().getY(), 4,
					0.01);
		} catch (NoSuchFieldException e) {
			fail("boundingCircle-Field fehlt" + e);
		} catch (Exception e) {
			fail("something failed!" + e);
		}

	}
}
